/* Generated By:JJTree&JavaCC: Do not edit this line. HiPiCompiler.java */
package hipi.compiler;

import java.util.Vector;

import java.io.File;

import hipi.compiler.checker.*;
import hipi.compiler.generator.*;
import hipi.compiler.encodings.*;

/**
 * Main class of the compiler.
 * Generated by JJTree and JavaCC.
 * 
 * @author Paolo Milazzo
 */
public class HiPiCompiler/*@bgen(jjtree)*/implements HiPiCompilerTreeConstants, HiPiCompilerConstants {/*@bgen(jjtree)*/
  protected JJTHiPiCompilerState jjtree = new JJTHiPiCompilerState();
    /**
     * Compiler signature: it is used as prefix for output messages
     * and it contains version number
     */
    public static final String COMP_DESC = "HiPi Compiler Version 0.1: ";

    // source file absolute path
    public static String sourceFile;

    // parser errors counter
    private static int hipi_error_num = 0;

    /**
     * pretty prints parse error messages 
     */
    public void hipi_parse_error(Token t, String msg) {
                hipi_error("PARSE ERROR",msg,t.beginLine,t.beginColumn);
    }

    /**
     * pretty prints syntax error messages 
     */
    public void hipi_syntax_error(SimpleNode node, String msg) {
        hipi_error("SYNTAX ERROR",msg,node.line,-1);
    }

    /**
     * pretty prints type error messages 
     */
    public void hipi_type_error(int line, String msg) {
        hipi_error("TYPE ERROR",msg,line,-1);
    }

    /**
     * pretty prints import error messages 
     */
    public void hipi_import_error(int line, String msg) {
        hipi_error("IMPORT ERROR",msg,line,-1);
    }

    // pretty prints error messages
    private void hipi_error(String type, String msg, int line, int column) {
        System.out.print(type + " (line " + line);
        if (column!=-1) System.out.print(",col " + column);
        System.out.println("): " + msg);
                if (++hipi_error_num > 20) {
                        System.out.println(COMP_DESC + "Too many errors... stop parsing");
                        System.exit(1);
                }
        }

    // consumes tokens when error occures
    private void hipi_error_skipto(String dest) {
                Token t = new Token();
        do {
                        t = getNextToken();
        } while (t.image.compareTo(dest) != 0);
        }

        /**
	 * Compiles an HiPi program
	 */
        public void compile() {
            try {
                    ASTHiPiProgram p = HiPiProgram();  // parsing
                    p.jjtAccept(new BuildImportVisitor(this), null); // add imports
                p.jjtAccept(new TreeChecker(this), null);       // checking
                p.jjtAccept(new SyncToAsyncVisitor(), null); // encoding
                p.jjtAccept(new AddForwardersVisitor(), null); // encoding
                p.jjtAccept(new RecDefsEncoding(), null); // encoding
                                p.jjtAccept(new CodeGenerator(), null); // generating code
            }
            catch(ParseException pe) {
                hipi_parse_error(pe.currentToken.next,pe.getMessage());
            }
            catch(TokenMgrError err) {
                hipi_parse_error(token,err.getMessage());
            }

            if (hipi_error_num == 0)
                System.out.println(COMP_DESC + "Program compiled succesfully");
            else
                System.out.println(COMP_DESC + hipi_error_num + " errors encountered");
        }

        /**
	 * Starts compiler execution reading from a source file given as input.
	 * If no input file is specified a usage message is shown.
	 *
	 * @param args source file name
	 */
    public static void main(String args[]) {

        if (args.length == 1) {
            System.out.println(COMP_DESC + "Reading from file " + args[0] + "...");
            // save absolute path of source file
            sourceFile = (new File(args[0])).getAbsolutePath();
            HiPiCompiler compiler = null;

            // initializing the compiler
            try {
                compiler =
                    new HiPiCompiler(new java.io.FileInputStream(args[0]));
            }
            catch(java.io.FileNotFoundException fnfe) {
                System.out.println(COMP_DESC + "File " + args[0] + " not found");
                System.exit(1);
            }

            // compilation of the input file
            compiler.compile();
        }
        else { // args.length == 0
            System.out.println(COMP_DESC + "Usage: hipic <inputfile>");
            System.exit(1);
        }
    }

/*
 ********************
 * LANGUAGE GRAMMAR *
 ********************
 */


/* MAIN RULE */
  final public ASTHiPiProgram HiPiProgram() throws ParseException {
 /*@bgen(jjtree) HiPiProgram */
  ASTHiPiProgram jjtn000 = new ASTHiPiProgram(JJTHIPIPROGRAM);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TYPEDEF:
          ;
          break;
        default:
          jj_la1[0] = jj_gen;
          break label_1;
        }
        TypeDeclaration();
      }
      label_2:
      while (true) {
        if (jj_2_1(2147483647)) {
          ;
        } else {
          break label_2;
        }
        GlobalChannelDeclaration();
      }
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IMPORT:
          ;
          break;
        default:
          jj_la1[1] = jj_gen;
          break label_3;
        }
        ImportDeclaration();
      }
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHANNEL:
        case INT:
        case STRING:
        case VOID:
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[2] = jj_gen;
          break label_4;
        }
        RecursiveDefinition();
      }
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SCHEDULE:
          ;
          break;
        default:
          jj_la1[3] = jj_gen;
          break label_5;
        }
        Schedule();
      }
      jj_consume_token(0);
              jjtree.closeNodeScope(jjtn000, true);
              jjtc000 = false;
                {if (true) return jjtn000;}
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public void GlobalChannelDeclaration() throws ParseException {
 /*@bgen(jjtree) GlobalChannelDeclaration */
        ASTGlobalChannelDeclaration jjtn000 = new ASTGlobalChannelDeclaration(JJTGLOBALCHANNELDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Token id;
        Token uri;
        Vector params = new Vector();
        int type;
    try {
      try {
        /*    	
        	<CHANNEL> "<" [ params=TypeList() ] ">" 
        	commented, now I switch to primitiveType() because I want to use
        	also type identifier. Type checking should be implemented (only channels are
        	admitted here)
        */
                        type = PrimitiveType(params);
        id = jj_consume_token(IDENTIFIER);
                        jjtn000.name = id.image;
                                jjtn000.type=type;
                        jjtn000.line = id.beginLine;
                        if (type==Types.CHANNEL) {
                                jjtn000.params = params;
                                jjtn000.typeId = null;
                        }
                        else if (type==Types.TYPEID) {
                                jjtn000.params = null;
                                jjtn000.typeId = (String) params.get(0);
                        }
                        else {
                                hipi_type_error(id.beginLine,"Error on global channel type");
                                hipi_error_skipto(";");
                        }
        jj_consume_token(34);
        uri = jj_consume_token(STRING_LITERAL);
        jj_consume_token(35);
                                // removing quotes from uri string
                                jjtn000.uri = uri.image.substring(1,uri.image.length() -1);
      } catch (ParseException pe) {
                hipi_parse_error(pe.currentToken.next,pe.getMessage());
                hipi_error_skipto(";");
      } catch (TokenMgrError err) {
                hipi_parse_error(token,err.getMessage());
                hipi_error_skipto(";");
      }
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

  final public void TypeDeclaration() throws ParseException {
 /*@bgen(jjtree) TypeDeclaration */
        ASTTypeDeclaration jjtn000 = new ASTTypeDeclaration(JJTTYPEDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Vector channelParams = new Vector();
        Token typeId;
        int realType;
    try {
      try {
        jj_consume_token(TYPEDEF);
        typeId = jj_consume_token(IDENTIFIER);
        jj_consume_token(34);
        realType = PrimitiveType(channelParams);
        jj_consume_token(35);
                                jjtn000.line = typeId.beginLine;
                                jjtn000.name = typeId.image;
                                jjtn000.realType = realType;
      } catch (ParseException pe) {
                hipi_parse_error(pe.currentToken.next,pe.getMessage());
                hipi_error_skipto(";");
      } catch (TokenMgrError err) {
                hipi_parse_error(token,err.getMessage());
                hipi_error_skipto(";");
      }
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

  final public void ImportDeclaration() throws ParseException {
 /*@bgen(jjtree) ImportDeclaration */
        ASTImportDeclaration jjtn000 = new ASTImportDeclaration(JJTIMPORTDECLARATION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Token file;
    try {
      try {
        jj_consume_token(IMPORT);
        file = jj_consume_token(STRING_LITERAL);
        jj_consume_token(35);
                                // removing quotes from fileName string
                                jjtn000.fileName =
                                        file.image.substring(1,file.image.length()-1);
                                jjtn000.line = file.beginLine;
      } catch (ParseException pe) {
                hipi_parse_error(pe.currentToken.next,pe.getMessage());
                hipi_error_skipto(";");
      } catch (TokenMgrError err) {
                hipi_parse_error(token,err.getMessage());
                hipi_error_skipto(";");
      }
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

  final public void RecursiveDefinition() throws ParseException {
 /*@bgen(jjtree) RecursiveDefinition */
        ASTRecursiveDefinition jjtn000 = new ASTRecursiveDefinition(JJTRECURSIVEDEFINITION);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Token id;
        int retType = Types.VOID;
        Vector channelParams = new Vector();
        Vector params = new Vector();
    try {
      try {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case VOID:
          jj_consume_token(VOID);
          break;
        case CHANNEL:
        case INT:
        case STRING:
        case IDENTIFIER:
          retType = PrimitiveType(channelParams);
          break;
        default:
          jj_la1[4] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        id = jj_consume_token(IDENTIFIER);
                        jjtn000.type = retType;
                        jjtn000.name = id.image;
                        jjtn000.line = id.beginLine;
                        if (retType==Types.TYPEID) {
                                jjtn000.typeId=(String)channelParams.get(0);
                                jjtn000.params=null;
                        }
                        else {
                                jjtn000.typeId=null;
                                jjtn000.params=channelParams;
                        }
        jj_consume_token(36);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHANNEL:
        case INT:
        case STRING:
        case IDENTIFIER:
          params = FormalParameterList();
          break;
        default:
          jj_la1[5] = jj_gen;
          ;
        }
        jj_consume_token(37);
                        jjtn000.params = params;
        Block(false);
      } catch (ParseException pe) {
                hipi_parse_error(pe.currentToken.next,pe.getMessage());
                hipi_error_skipto("}");
      } catch (TokenMgrError err) {
                hipi_parse_error(token,err.getMessage());
                hipi_error_skipto("}");
      }
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

  final public void Schedule() throws ParseException {
 /*@bgen(jjtree) Schedule */
        ASTSchedule jjtn000 = new ASTSchedule(JJTSCHEDULE);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Vector idList = new Vector();
        Token tmp=null;
        Token name;
        Token id;
    try {
      try {
        jj_consume_token(SCHEDULE);
        name = jj_consume_token(IDENTIFIER);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLOCATEDWITH:
          jj_consume_token(COLOCATEDWITH);
          id = jj_consume_token(IDENTIFIER);
                          idList.add(id.image);
          label_6:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case 38:
              ;
              break;
            default:
              jj_la1[6] = jj_gen;
              break label_6;
            }
            jj_consume_token(38);
            id = jj_consume_token(IDENTIFIER);
                          idList.add(id.image);
          }
          break;
        default:
          jj_la1[7] = jj_gen;
          ;
        }
                        jjtn000.colocations = idList;
                        jjtn000.name = name.image;
                        jjtn000.line = name.beginLine;
        jj_consume_token(39);
        label_7:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case CHANNEL:
          case INT:
          case MAIN:
          case STRING:
          case VOID:
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[8] = jj_gen;
            break label_7;
          }
          if (jj_2_2(2147483647)) {
            LocalDeclarationStatement();
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case CHANNEL:
            case INT:
            case STRING:
            case VOID:
            case IDENTIFIER:
              RecursiveDefinition();
              break;
            case MAIN:
              jj_consume_token(MAIN);
              jj_consume_token(39);
                                  ASTScheduleMain jjtn001 = new ASTScheduleMain(JJTSCHEDULEMAIN);
                                  boolean jjtc001 = true;
                                  jjtree.openNodeScope(jjtn001);
              try {
                label_8:
                while (true) {
                  switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                  case CHANNEL:
                  case IF:
                  case INT:
                  case RETURN:
                  case SPAWN:
                  case SPAWNAT:
                  case STRING:
                  case IDENTIFIER:
                  case 39:
                    ;
                    break;
                  default:
                    jj_la1[9] = jj_gen;
                    break label_8;
                  }
                  Statement();
                }
              } catch (Throwable jjte001) {
                                  if (jjtc001) {
                                    jjtree.clearNodeScope(jjtn001);
                                    jjtc001 = false;
                                  } else {
                                    jjtree.popNode();
                                  }
                                  if (jjte001 instanceof RuntimeException) {
                                    {if (true) throw (RuntimeException)jjte001;}
                                  }
                                  if (jjte001 instanceof ParseException) {
                                    {if (true) throw (ParseException)jjte001;}
                                  }
                                  {if (true) throw (Error)jjte001;}
              } finally {
                                  if (jjtc001) {
                                    jjtree.closeNodeScope(jjtn001, true);
                                  }
              }
              jj_consume_token(40);
              break;
            default:
              jj_la1[10] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
        jj_consume_token(40);
      } catch (ParseException pe) {
                hipi_parse_error(pe.currentToken.next,pe.getMessage());
                hipi_error_skipto("}");
      } catch (TokenMgrError err) {
                hipi_parse_error(token,err.getMessage());
                hipi_error_skipto("}");
      }
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

/* BLOCK AND BODY */
  final public void Block(boolean createASTNode) throws ParseException {
 /*@bgen(jjtree) #Block( createASTNode) */
  ASTBlock jjtn000 = new ASTBlock(JJTBLOCK);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      jj_consume_token(39);
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHANNEL:
        case IF:
        case INT:
        case RETURN:
        case SPAWN:
        case SPAWNAT:
        case STRING:
        case IDENTIFIER:
        case 39:
          ;
          break;
        default:
          jj_la1[11] = jj_gen;
          break label_9;
        }
        Statement();
      }
      jj_consume_token(40);
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000,  createASTNode);
      }
    }
  }

  final public void LocalDeclarationStatement() throws ParseException {
 /*@bgen(jjtree) LocalDeclarationStatement */
        ASTLocalDeclarationStatement jjtn000 = new ASTLocalDeclarationStatement(JJTLOCALDECLARATIONSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Token id;
        int t;
        Vector params = new Vector();
    try {
      t = PrimitiveType(params);
      id = jj_consume_token(IDENTIFIER);
                        jjtn000.type = t;
                        jjtn000.name = id.image;
                        if (t==Types.TYPEID) {
                                jjtn000.params = null;
                                jjtn000.typeId = (String)params.get(0);
                        }
                        else {
                                jjtn000.params = params;
                                jjtn000.typeId = null;
                        }
                        jjtn000.line = id.beginLine;
                        jjtn000.TC_visited = false;
                        jjtn000.CG_visited = false;
      jj_consume_token(34);
      Expression();
      jj_consume_token(35);
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

/* STATEMENTS */
  final public void Statement() throws ParseException {
    try {
      if (jj_2_3(2)) {
        CommunicationStatement();
      } else if (jj_2_4(2)) {
        LocalDeclarationStatement();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          RecursiveDefinitionCallStatement();
          break;
        case SPAWN:
        case SPAWNAT:
          SpawnStatement();
          break;
        case IF:
          SelectionStatement();
          break;
        case RETURN:
          ReturnStatement();
          break;
        case 39:
          Block(true);
          break;
        default:
          jj_la1[12] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (ParseException pe) {
                hipi_parse_error(pe.currentToken.next,pe.getMessage());
                hipi_error_skipto(";");
    } catch (TokenMgrError err) {
                hipi_parse_error(token,err.getMessage());
                hipi_error_skipto(";");
    }
  }

  final public void CommunicationStatement() throws ParseException {
        Token id;
        Vector idList=null;
        Vector params=new Vector();
    id = jj_consume_token(IDENTIFIER);
    jj_consume_token(41);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEND:
                  ASTSend jjtn001 = new ASTSend(JJTSEND);
                  boolean jjtc001 = true;
                  jjtree.openNodeScope(jjtn001);
      try {
        jj_consume_token(SEND);
        jj_consume_token(36);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER_LITERAL:
        case STRING_LITERAL:
        case FALSE:
        case NEW:
        case TRUE:
        case IDENTIFIER:
        case 36:
        case 51:
        case 55:
          ActualParameterList();
          break;
        default:
          jj_la1[13] = jj_gen;
          ;
        }
                          jjtree.closeNodeScope(jjtn001, true);
                          jjtc001 = false;
                          jjtn001.name = id.image;
                          jjtn001.line = id.beginLine;
      } catch (Throwable jjte001) {
                  if (jjtc001) {
                    jjtree.clearNodeScope(jjtn001);
                    jjtc001 = false;
                  } else {
                    jjtree.popNode();
                  }
                  if (jjte001 instanceof RuntimeException) {
                    {if (true) throw (RuntimeException)jjte001;}
                  }
                  if (jjte001 instanceof ParseException) {
                    {if (true) throw (ParseException)jjte001;}
                  }
                  {if (true) throw (Error)jjte001;}
      } finally {
                  if (jjtc001) {
                    jjtree.closeNodeScope(jjtn001, true);
                  }
      }
      break;
    case ASEND:
                  ASTSpawnStatement jjtn003 = new ASTSpawnStatement(JJTSPAWNSTATEMENT);
                  boolean jjtc003 = true;
                  jjtree.openNodeScope(jjtn003);
      try {
                    ASTSend jjtn002 = new ASTSend(JJTSEND);
                    boolean jjtc002 = true;
                    jjtree.openNodeScope(jjtn002);
        try {
          jj_consume_token(ASEND);
          jj_consume_token(36);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case INTEGER_LITERAL:
          case STRING_LITERAL:
          case FALSE:
          case NEW:
          case TRUE:
          case IDENTIFIER:
          case 36:
          case 51:
          case 55:
            ActualParameterList();
            break;
          default:
            jj_la1[14] = jj_gen;
            ;
          }
                           jjtree.closeNodeScope(jjtn002, true);
                           jjtc002 = false;
                           jjtn002.name = id.image;
                           jjtn002.line = id.beginLine;
        } catch (Throwable jjte002) {
                    if (jjtc002) {
                      jjtree.clearNodeScope(jjtn002);
                      jjtc002 = false;
                    } else {
                      jjtree.popNode();
                    }
                    if (jjte002 instanceof RuntimeException) {
                      {if (true) throw (RuntimeException)jjte002;}
                    }
                    if (jjte002 instanceof ParseException) {
                      {if (true) throw (ParseException)jjte002;}
                    }
                    {if (true) throw (Error)jjte002;}
        } finally {
                    if (jjtc002) {
                      jjtree.closeNodeScope(jjtn002, true);
                    }
        }
                      jjtree.closeNodeScope(jjtn003, true);
                      jjtc003 = false;
                                jjtn003.isMigration = false;
                                jjtn003.CG_visited = false;
                                jjtn003.nameGiven = false;
                                jjtn003.line = token.beginLine;
      } catch (Throwable jjte003) {
                  if (jjtc003) {
                    jjtree.clearNodeScope(jjtn003);
                    jjtc003 = false;
                  } else {
                    jjtree.popNode();
                  }
                  if (jjte003 instanceof RuntimeException) {
                    {if (true) throw (RuntimeException)jjte003;}
                  }
                  if (jjte003 instanceof ParseException) {
                    {if (true) throw (ParseException)jjte003;}
                  }
                  {if (true) throw (Error)jjte003;}
      } finally {
                  if (jjtc003) {
                    jjtree.closeNodeScope(jjtn003, true);
                  }
      }
      break;
    case RECV:
                  ASTRecv jjtn004 = new ASTRecv(JJTRECV);
                  boolean jjtc004 = true;
                  jjtree.openNodeScope(jjtn004);
      try {
        jj_consume_token(RECV);
        jj_consume_token(36);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHANNEL:
        case INT:
        case STRING:
        case IDENTIFIER:
          params = FormalParameterList();
          break;
        default:
          jj_la1[15] = jj_gen;
          ;
        }
                          jjtree.closeNodeScope(jjtn004, true);
                          jjtc004 = false;
                          jjtn004.name = id.image;
                          jjtn004.line = id.beginLine;
                          jjtn004.params = params;
      } catch (Throwable jjte004) {
                  if (jjtc004) {
                    jjtree.clearNodeScope(jjtn004);
                    jjtc004 = false;
                  } else {
                    jjtree.popNode();
                  }
                  if (jjte004 instanceof RuntimeException) {
                    {if (true) throw (RuntimeException)jjte004;}
                  }
                  if (jjte004 instanceof ParseException) {
                    {if (true) throw (ParseException)jjte004;}
                  }
                  {if (true) throw (Error)jjte004;}
      } finally {
                  if (jjtc004) {
                    jjtree.closeNodeScope(jjtn004, true);
                  }
      }
      break;
    default:
      jj_la1[16] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(37);
    jj_consume_token(35);
  }

  final public void RecursiveDefinitionCallStatement() throws ParseException {
    RecursiveDefinitionCall();
    jj_consume_token(35);
  }

  final public void RecursiveDefinitionCall() throws ParseException {
 /*@bgen(jjtree) RecursiveDefinitionCall */
        ASTRecursiveDefinitionCall jjtn000 = new ASTRecursiveDefinitionCall(JJTRECURSIVEDEFINITIONCALL);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Token id;
    try {
      id = jj_consume_token(IDENTIFIER);
      jj_consume_token(36);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
      case STRING_LITERAL:
      case FALSE:
      case NEW:
      case TRUE:
      case IDENTIFIER:
      case 36:
      case 51:
      case 55:
        ActualParameterList();
        break;
      default:
        jj_la1[17] = jj_gen;
        ;
      }
      jj_consume_token(37);
          jjtree.closeNodeScope(jjtn000, true);
          jjtc000 = false;
                jjtn000.name = id.image;
                jjtn000.line = id.beginLine;
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void SpawnStatement() throws ParseException {
 /*@bgen(jjtree) SpawnStatement */
        ASTSpawnStatement jjtn000 = new ASTSpawnStatement(JJTSPAWNSTATEMENT);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Token id;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SPAWN:
        jj_consume_token(SPAWN);
                        jjtn000.isMigration = false;
                        jjtn000.CG_visited = false;
                        jjtn000.nameGiven = false;
                        jjtn000.line = token.beginLine;
        break;
      case SPAWNAT:
        jj_consume_token(SPAWNAT);
        id = jj_consume_token(IDENTIFIER);
                        jjtn000.dest = id.image;
                        jjtn000.isMigration = true;
                        jjtn000.CG_visited = false;
                        jjtn000.nameGiven = false;
                        jjtn000.line = token.beginLine;
        break;
      default:
        jj_la1[18] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Block(false);
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void SelectionStatement() throws ParseException {
 /*@bgen(jjtree) SelectionStatement */
  ASTSelectionStatement jjtn000 = new ASTSelectionStatement(JJTSELECTIONSTATEMENT);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      jj_consume_token(IF);
      jj_consume_token(36);
      Expression();
      jj_consume_token(37);
      Statement();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELSE:
        jj_consume_token(ELSE);
        Statement();
        break;
      default:
        jj_la1[19] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void ReturnStatement() throws ParseException {
 /*@bgen(jjtree) ReturnStatement */
  ASTReturnStatement jjtn000 = new ASTReturnStatement(JJTRETURNSTATEMENT);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      jj_consume_token(RETURN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
      case STRING_LITERAL:
      case FALSE:
      case NEW:
      case TRUE:
      case IDENTIFIER:
      case 36:
      case 51:
      case 55:
        Expression();
        break;
      default:
        jj_la1[20] = jj_gen;
        ;
      }
      jj_consume_token(35);
    } catch (Throwable jjte000) {
          if (jjtc000) {
            jjtree.clearNodeScope(jjtn000);
            jjtc000 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte000 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte000;}
          }
          if (jjte000 instanceof ParseException) {
            {if (true) throw (ParseException)jjte000;}
          }
          {if (true) throw (Error)jjte000;}
    } finally {
          if (jjtc000) {
            jjtree.closeNodeScope(jjtn000, true);
          }
    }
  }

/* EXPRESSIONS */
  final public void Expression() throws ParseException {
    ConditionalAndExpression();
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 42:
        ;
        break;
      default:
        jj_la1[21] = jj_gen;
        break label_10;
      }
      ASTExpOp jjtn001 = new ASTExpOp(JJTEXPOP);
      boolean jjtc001 = true;
      jjtree.openNodeScope(jjtn001);
      try {
        jj_consume_token(42);
        ConditionalAndExpression();
                  jjtree.closeNodeScope(jjtn001,  2);
                  jjtc001 = false;
                        jjtn001.operator = "or";
      } catch (Throwable jjte001) {
      if (jjtc001) {
        jjtree.clearNodeScope(jjtn001);
        jjtc001 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte001 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte001;}
      }
      if (jjte001 instanceof ParseException) {
        {if (true) throw (ParseException)jjte001;}
      }
      {if (true) throw (Error)jjte001;}
      } finally {
      if (jjtc001) {
        jjtree.closeNodeScope(jjtn001,  2);
      }
      }
    }
  }

  final public void ConditionalAndExpression() throws ParseException {
    EqualityExpression();
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 43:
        ;
        break;
      default:
        jj_la1[22] = jj_gen;
        break label_11;
      }
      ASTExpOp jjtn001 = new ASTExpOp(JJTEXPOP);
      boolean jjtc001 = true;
      jjtree.openNodeScope(jjtn001);
      try {
        jj_consume_token(43);
        EqualityExpression();
                  jjtree.closeNodeScope(jjtn001,  2);
                  jjtc001 = false;
                        jjtn001.operator = "and";
      } catch (Throwable jjte001) {
      if (jjtc001) {
        jjtree.clearNodeScope(jjtn001);
        jjtc001 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte001 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte001;}
      }
      if (jjte001 instanceof ParseException) {
        {if (true) throw (ParseException)jjte001;}
      }
      {if (true) throw (Error)jjte001;}
      } finally {
      if (jjtc001) {
        jjtree.closeNodeScope(jjtn001,  2);
      }
      }
    }
  }

  final public void EqualityExpression() throws ParseException {
    RelationalExpression();
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 44:
      case 45:
        ;
        break;
      default:
        jj_la1[23] = jj_gen;
        break label_12;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 44:
       ASTExpOp jjtn001 = new ASTExpOp(JJTEXPOP);
       boolean jjtc001 = true;
       jjtree.openNodeScope(jjtn001);
        try {
          jj_consume_token(44);
          RelationalExpression();
          jjtree.closeNodeScope(jjtn001,  2);
          jjtc001 = false;
                jjtn001.operator="eq";
        } catch (Throwable jjte001) {
       if (jjtc001) {
         jjtree.clearNodeScope(jjtn001);
         jjtc001 = false;
       } else {
         jjtree.popNode();
       }
       if (jjte001 instanceof RuntimeException) {
         {if (true) throw (RuntimeException)jjte001;}
       }
       if (jjte001 instanceof ParseException) {
         {if (true) throw (ParseException)jjte001;}
       }
       {if (true) throw (Error)jjte001;}
        } finally {
       if (jjtc001) {
         jjtree.closeNodeScope(jjtn001,  2);
       }
        }
        break;
      case 45:
       ASTExpOp jjtn002 = new ASTExpOp(JJTEXPOP);
       boolean jjtc002 = true;
       jjtree.openNodeScope(jjtn002);
        try {
          jj_consume_token(45);
          RelationalExpression();
          jjtree.closeNodeScope(jjtn002,  2);
          jjtc002 = false;
                jjtn002.operator="neq";
        } catch (Throwable jjte002) {
       if (jjtc002) {
         jjtree.clearNodeScope(jjtn002);
         jjtc002 = false;
       } else {
         jjtree.popNode();
       }
       if (jjte002 instanceof RuntimeException) {
         {if (true) throw (RuntimeException)jjte002;}
       }
       if (jjte002 instanceof ParseException) {
         {if (true) throw (ParseException)jjte002;}
       }
       {if (true) throw (Error)jjte002;}
        } finally {
       if (jjtc002) {
         jjtree.closeNodeScope(jjtn002,  2);
       }
        }
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void RelationalExpression() throws ParseException {
    AdditiveExpression();
    label_13:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 46:
      case 47:
      case 48:
      case 49:
        ;
        break;
      default:
        jj_la1[25] = jj_gen;
        break label_13;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 46:
      ASTExpOp jjtn001 = new ASTExpOp(JJTEXPOP);
      boolean jjtc001 = true;
      jjtree.openNodeScope(jjtn001);
        try {
          jj_consume_token(46);
          AdditiveExpression();
          jjtree.closeNodeScope(jjtn001,  2);
          jjtc001 = false;
                jjtn001.operator="lt";
        } catch (Throwable jjte001) {
      if (jjtc001) {
        jjtree.clearNodeScope(jjtn001);
        jjtc001 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte001 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte001;}
      }
      if (jjte001 instanceof ParseException) {
        {if (true) throw (ParseException)jjte001;}
      }
      {if (true) throw (Error)jjte001;}
        } finally {
      if (jjtc001) {
        jjtree.closeNodeScope(jjtn001,  2);
      }
        }
        break;
      case 47:
      ASTExpOp jjtn002 = new ASTExpOp(JJTEXPOP);
      boolean jjtc002 = true;
      jjtree.openNodeScope(jjtn002);
        try {
          jj_consume_token(47);
          AdditiveExpression();
          jjtree.closeNodeScope(jjtn002,  2);
          jjtc002 = false;
                jjtn002.operator="gt";
        } catch (Throwable jjte002) {
      if (jjtc002) {
        jjtree.clearNodeScope(jjtn002);
        jjtc002 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte002 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte002;}
      }
      if (jjte002 instanceof ParseException) {
        {if (true) throw (ParseException)jjte002;}
      }
      {if (true) throw (Error)jjte002;}
        } finally {
      if (jjtc002) {
        jjtree.closeNodeScope(jjtn002,  2);
      }
        }
        break;
      case 48:
      ASTExpOp jjtn003 = new ASTExpOp(JJTEXPOP);
      boolean jjtc003 = true;
      jjtree.openNodeScope(jjtn003);
        try {
          jj_consume_token(48);
          AdditiveExpression();
          jjtree.closeNodeScope(jjtn003,  2);
          jjtc003 = false;
                jjtn003.operator="le";
        } catch (Throwable jjte003) {
      if (jjtc003) {
        jjtree.clearNodeScope(jjtn003);
        jjtc003 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte003 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte003;}
      }
      if (jjte003 instanceof ParseException) {
        {if (true) throw (ParseException)jjte003;}
      }
      {if (true) throw (Error)jjte003;}
        } finally {
      if (jjtc003) {
        jjtree.closeNodeScope(jjtn003,  2);
      }
        }
        break;
      case 49:
      ASTExpOp jjtn004 = new ASTExpOp(JJTEXPOP);
      boolean jjtc004 = true;
      jjtree.openNodeScope(jjtn004);
        try {
          jj_consume_token(49);
          AdditiveExpression();
          jjtree.closeNodeScope(jjtn004,  2);
          jjtc004 = false;
                jjtn004.operator="ge";
        } catch (Throwable jjte004) {
      if (jjtc004) {
        jjtree.clearNodeScope(jjtn004);
        jjtc004 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte004 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte004;}
      }
      if (jjte004 instanceof ParseException) {
        {if (true) throw (ParseException)jjte004;}
      }
      {if (true) throw (Error)jjte004;}
        } finally {
      if (jjtc004) {
        jjtree.closeNodeScope(jjtn004,  2);
      }
        }
        break;
      default:
        jj_la1[26] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void AdditiveExpression() throws ParseException {
    MultiplicativeExpression();
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 50:
      case 51:
        ;
        break;
      default:
        jj_la1[27] = jj_gen;
        break label_14;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 50:
      ASTExpOp jjtn001 = new ASTExpOp(JJTEXPOP);
      boolean jjtc001 = true;
      jjtree.openNodeScope(jjtn001);
        try {
          jj_consume_token(50);
          MultiplicativeExpression();
          jjtree.closeNodeScope(jjtn001,  2);
          jjtc001 = false;
                jjtn001.operator="add";
        } catch (Throwable jjte001) {
      if (jjtc001) {
        jjtree.clearNodeScope(jjtn001);
        jjtc001 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte001 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte001;}
      }
      if (jjte001 instanceof ParseException) {
        {if (true) throw (ParseException)jjte001;}
      }
      {if (true) throw (Error)jjte001;}
        } finally {
      if (jjtc001) {
        jjtree.closeNodeScope(jjtn001,  2);
      }
        }
        break;
      case 51:
      ASTExpOp jjtn002 = new ASTExpOp(JJTEXPOP);
      boolean jjtc002 = true;
      jjtree.openNodeScope(jjtn002);
        try {
          jj_consume_token(51);
          MultiplicativeExpression();
          jjtree.closeNodeScope(jjtn002,  2);
          jjtc002 = false;
                jjtn002.operator="sub";
        } catch (Throwable jjte002) {
      if (jjtc002) {
        jjtree.clearNodeScope(jjtn002);
        jjtc002 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte002 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte002;}
      }
      if (jjte002 instanceof ParseException) {
        {if (true) throw (ParseException)jjte002;}
      }
      {if (true) throw (Error)jjte002;}
        } finally {
      if (jjtc002) {
        jjtree.closeNodeScope(jjtn002,  2);
      }
        }
        break;
      default:
        jj_la1[28] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void MultiplicativeExpression() throws ParseException {
    UnaryExpression();
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 52:
      case 53:
      case 54:
        ;
        break;
      default:
        jj_la1[29] = jj_gen;
        break label_15;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 52:
      ASTExpOp jjtn001 = new ASTExpOp(JJTEXPOP);
      boolean jjtc001 = true;
      jjtree.openNodeScope(jjtn001);
        try {
          jj_consume_token(52);
          UnaryExpression();
          jjtree.closeNodeScope(jjtn001,  2);
          jjtc001 = false;
                jjtn001.operator="mul";
        } catch (Throwable jjte001) {
      if (jjtc001) {
        jjtree.clearNodeScope(jjtn001);
        jjtc001 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte001 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte001;}
      }
      if (jjte001 instanceof ParseException) {
        {if (true) throw (ParseException)jjte001;}
      }
      {if (true) throw (Error)jjte001;}
        } finally {
      if (jjtc001) {
        jjtree.closeNodeScope(jjtn001,  2);
      }
        }
        break;
      case 53:
      ASTExpOp jjtn002 = new ASTExpOp(JJTEXPOP);
      boolean jjtc002 = true;
      jjtree.openNodeScope(jjtn002);
        try {
          jj_consume_token(53);
          UnaryExpression();
          jjtree.closeNodeScope(jjtn002,  2);
          jjtc002 = false;
                jjtn002.operator="div";
        } catch (Throwable jjte002) {
      if (jjtc002) {
        jjtree.clearNodeScope(jjtn002);
        jjtc002 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte002 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte002;}
      }
      if (jjte002 instanceof ParseException) {
        {if (true) throw (ParseException)jjte002;}
      }
      {if (true) throw (Error)jjte002;}
        } finally {
      if (jjtc002) {
        jjtree.closeNodeScope(jjtn002,  2);
      }
        }
        break;
      case 54:
      ASTExpOp jjtn003 = new ASTExpOp(JJTEXPOP);
      boolean jjtc003 = true;
      jjtree.openNodeScope(jjtn003);
        try {
          jj_consume_token(54);
          UnaryExpression();
          jjtree.closeNodeScope(jjtn003,  2);
          jjtc003 = false;
                jjtn003.operator="mod";
        } catch (Throwable jjte003) {
      if (jjtc003) {
        jjtree.clearNodeScope(jjtn003);
        jjtc003 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte003 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte003;}
      }
      if (jjte003 instanceof ParseException) {
        {if (true) throw (ParseException)jjte003;}
      }
      {if (true) throw (Error)jjte003;}
        } finally {
      if (jjtc003) {
        jjtree.closeNodeScope(jjtn003,  2);
      }
        }
        break;
      default:
        jj_la1[30] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void UnaryExpression() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 51:
    ASTExpOp jjtn001 = new ASTExpOp(JJTEXPOP);
    boolean jjtc001 = true;
    jjtree.openNodeScope(jjtn001);
      try {
        jj_consume_token(51);
        UnaryExpression();
          jjtree.closeNodeScope(jjtn001,  1);
          jjtc001 = false;
                jjtn001.operator="umin";
      } catch (Throwable jjte001) {
    if (jjtc001) {
      jjtree.clearNodeScope(jjtn001);
      jjtc001 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte001 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte001;}
    }
    if (jjte001 instanceof ParseException) {
      {if (true) throw (ParseException)jjte001;}
    }
    {if (true) throw (Error)jjte001;}
      } finally {
    if (jjtc001) {
      jjtree.closeNodeScope(jjtn001,  1);
    }
      }
      break;
    case 55:
    ASTExpOp jjtn002 = new ASTExpOp(JJTEXPOP);
    boolean jjtc002 = true;
    jjtree.openNodeScope(jjtn002);
      try {
        jj_consume_token(55);
        UnaryExpression();
          jjtree.closeNodeScope(jjtn002,  1);
          jjtc002 = false;
                jjtn002.operator="not";
      } catch (Throwable jjte002) {
    if (jjtc002) {
      jjtree.clearNodeScope(jjtn002);
      jjtc002 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte002 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte002;}
    }
    if (jjte002 instanceof ParseException) {
      {if (true) throw (ParseException)jjte002;}
    }
    {if (true) throw (Error)jjte002;}
      } finally {
    if (jjtc002) {
      jjtree.closeNodeScope(jjtn002,  1);
    }
      }
      break;
    case INTEGER_LITERAL:
    case STRING_LITERAL:
    case FALSE:
    case NEW:
    case TRUE:
    case IDENTIFIER:
    case 36:
      PrimaryExpression();
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void PrimaryExpression() throws ParseException {
        Token id;
    if (jj_2_5(2)) {
      RecursiveDefinitionCall();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
       ASTExpIdentifier jjtn001 = new ASTExpIdentifier(JJTEXPIDENTIFIER);
       boolean jjtc001 = true;
       jjtree.openNodeScope(jjtn001);
        try {
          id = jj_consume_token(IDENTIFIER);
          jjtree.closeNodeScope(jjtn001, true);
          jjtc001 = false;
                jjtn001.name = id.image;
                jjtn001.line = id.beginLine;
        } finally {
       if (jjtc001) {
         jjtree.closeNodeScope(jjtn001, true);
       }
        }
        break;
      case INTEGER_LITERAL:
            ASTExpInteger jjtn002 = new ASTExpInteger(JJTEXPINTEGER);
            boolean jjtc002 = true;
            jjtree.openNodeScope(jjtn002);
        try {
          id = jj_consume_token(INTEGER_LITERAL);
          jjtree.closeNodeScope(jjtn002, true);
          jjtc002 = false;
                jjtn002.value = id.image;
                jjtn002.line = id.beginLine;
        } finally {
            if (jjtc002) {
              jjtree.closeNodeScope(jjtn002, true);
            }
        }
        break;
      case STRING_LITERAL:
        ASTExpString jjtn003 = new ASTExpString(JJTEXPSTRING);
        boolean jjtc003 = true;
        jjtree.openNodeScope(jjtn003);
        try {
          id = jj_consume_token(STRING_LITERAL);
          jjtree.closeNodeScope(jjtn003, true);
          jjtc003 = false;
                jjtn003.value = id.image.substring(1,id.image.length()-1);;
                jjtn003.line = id.beginLine;
        } finally {
        if (jjtc003) {
          jjtree.closeNodeScope(jjtn003, true);
        }
        }
        break;
      case TRUE:
        ASTExpInteger jjtn004 = new ASTExpInteger(JJTEXPINTEGER);
        boolean jjtc004 = true;
        jjtree.openNodeScope(jjtn004);
        try {
          id = jj_consume_token(TRUE);
          jjtree.closeNodeScope(jjtn004, true);
          jjtc004 = false;
                jjtn004.value = "1";
                jjtn004.line = id.beginLine;
        } finally {
        if (jjtc004) {
          jjtree.closeNodeScope(jjtn004, true);
        }
        }
        break;
      case FALSE:
        ASTExpInteger jjtn005 = new ASTExpInteger(JJTEXPINTEGER);
        boolean jjtc005 = true;
        jjtree.openNodeScope(jjtn005);
        try {
          id = jj_consume_token(FALSE);
          jjtree.closeNodeScope(jjtn005, true);
          jjtc005 = false;
                jjtn005.value = "0";
                jjtn005.line = id.beginLine;
        } finally {
        if (jjtc005) {
          jjtree.closeNodeScope(jjtn005, true);
        }
        }
        break;
      case NEW:
        ASTNewChannel jjtn006 = new ASTNewChannel(JJTNEWCHANNEL);
        boolean jjtc006 = true;
        jjtree.openNodeScope(jjtn006);
        try {
          jj_consume_token(NEW);
          jj_consume_token(CHANNEL);
        } finally {
        if (jjtc006) {
          jjtree.closeNodeScope(jjtn006, true);
        }
        }
        break;
      case 36:
        jj_consume_token(36);
        Expression();
        jj_consume_token(37);
        break;
      default:
        jj_la1[32] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/* LISTS */
  final public void ActualParameterList() throws ParseException {
    Expression();
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 38:
        ;
        break;
      default:
        jj_la1[33] = jj_gen;
        break label_16;
      }
      jj_consume_token(38);
      Expression();
    }
  }

  final public Vector FormalParameterList() throws ParseException {
        Vector values = null;
        Vector chParams = new Vector();
        int tmpType;
        Token id;
    tmpType = PrimitiveType(chParams);
    id = jj_consume_token(IDENTIFIER);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 38:
      jj_consume_token(38);
      values = FormalParameterList();
      break;
    default:
      jj_la1[34] = jj_gen;
      ;
    }
                // update the returned vector
                if (values == null) values = new Vector();
                // little abuse... if tmpType is typeId, chParams contains the realType
                        values.add(0,new FormalParamDescriptor(id.image, tmpType, chParams));
                {if (true) return values;}

                // returns a Vector containing FormalParamDescriptors

    throw new Error("Missing return statement in function");
  }

  final public Vector TypeList() throws ParseException {
        Vector values = null;
        Vector channelParams = new Vector();
        int tmpType;
    tmpType = PrimitiveType(channelParams);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 38:
      jj_consume_token(38);
      values = TypeList();
      break;
    default:
      jj_la1[35] = jj_gen;
      ;
    }
                        if (tmpType==Types.TYPEID) {
                                hipi_type_error(token.beginLine,
                                        "Type identifier inside type declarations not implemented");
                        }
                        else {
                        if (values == null) values = new Vector();
                                values.add(0,new Integer(tmpType));
                                {if (true) return values;}
                        }

                        // returns a Vector containing integers (TODO types)

    throw new Error("Missing return statement in function");
  }

/* TYPES */
  final public int PrimitiveType(Vector channelParams) throws ParseException {
        Vector tmpTypes = new Vector();
        Token id;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CHANNEL:
      jj_consume_token(CHANNEL);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 46:
        jj_consume_token(46);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CHANNEL:
        case INT:
        case STRING:
        case IDENTIFIER:
          tmpTypes = TypeList();
          break;
        default:
          jj_la1[36] = jj_gen;
          ;
        }
        jj_consume_token(47);
        break;
      default:
        jj_la1[37] = jj_gen;
        ;
      }
                if (channelParams!=null) {
                        channelParams.clear();
                        channelParams.addAll(tmpTypes);
                }
                {if (true) return Types.CHANNEL;}
      break;
    case INT:
      jj_consume_token(INT);
                {if (true) return Types.INT;}
      break;
    case STRING:
      jj_consume_token(STRING);
                   {if (true) return Types.STRING;}
      break;
    case IDENTIFIER:
      id = jj_consume_token(IDENTIFIER);
                        channelParams.add(id.image);
                {if (true) return Types.TYPEID;}
      break;
    default:
      jj_la1[38] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_3R_59() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_scan_token(48)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(34)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(35)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_scan_token(CHANNEL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_29()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_21() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_23()) {
    jj_scanpos = xsp;
    if (jj_3R_24()) {
    jj_scanpos = xsp;
    if (jj_3R_25()) {
    jj_scanpos = xsp;
    if (jj_3R_26()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_17()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    if (jj_scan_token(47)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_5()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) {
    jj_scanpos = xsp;
    if (jj_3R_59()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) {
    jj_scanpos = xsp;
    if (jj_3R_62()) {
    jj_scanpos = xsp;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(36)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_65()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(37)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_20()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_58() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_37() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_3R_44()) {
    jj_scanpos = xsp;
    if (jj_3R_45()) {
    jj_scanpos = xsp;
    if (jj_3R_46()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_scan_token(46)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_37()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_scan_token(38)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_scan_token(45)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_33()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_35() {
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_40()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    if (jj_scan_token(55)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_scan_token(44)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_33()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(41)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_3R_33()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_34()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_51() {
    if (jj_scan_token(51)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_51()) {
    jj_scanpos = xsp;
    if (jj_3R_52()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_scan_token(43)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_30()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() {
    if (jj_scan_token(54)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_27() {
    if (jj_3R_30()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_31()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_scan_token(38)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() {
    if (jj_scan_token(53)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_28() {
    if (jj_scan_token(42)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_27()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_54() {
    if (jj_scan_token(52)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_54()) {
    jj_scanpos = xsp;
    if (jj_3R_55()) {
    jj_scanpos = xsp;
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_3R_27()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_28()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_48()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_19()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_67()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_64() {
    if (jj_scan_token(36)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(37)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_scan_token(NEW)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(CHANNEL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() {
    if (jj_scan_token(51)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() {
    if (jj_scan_token(50)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_49()) {
    jj_scanpos = xsp;
    if (jj_3R_50()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_62() {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_42()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_65() {
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(46)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_32()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(47)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_26() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_scan_token(49)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_scan_token(INT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_17() {
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(34)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(35)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public HiPiCompilerTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[39];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x10000000,0x10000,0x64020800,0x400000,0x64020800,0x44020800,0x0,0x1000,0x64060800,0x47228800,0x64060800,0x47228800,0x43208000,0x48084300,0x48084300,0x44020800,0x900400,0x48084300,0x3000000,0x2000,0x48084300,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x48084300,0x48084300,0x0,0x0,0x0,0x44020800,0x0,0x44020800,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x80,0x0,0x80,0x80,0x880010,0x880010,0x0,0x0,0x880010,0x0,0x0,0x880010,0x400,0x800,0x3000,0x3000,0x3c000,0x3c000,0xc0000,0xc0000,0x700000,0x700000,0x880010,0x10,0x40,0x40,0x40,0x0,0x4000,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[5];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public HiPiCompiler(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new HiPiCompilerTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 39; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 39; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public HiPiCompiler(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new HiPiCompilerTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 39; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 39; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public HiPiCompiler(HiPiCompilerTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 39; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(HiPiCompilerTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 39; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[56];
    for (int i = 0; i < 56; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 39; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 56; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 5; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
